# Compile instructions

- The code does not have many dependencies. It essentially requires GMSH, Eigen, Lua and SILO. On Debian they are installed with `apt install libeigen3-dev libsilo-dev libsiloh5-0 liblua5.3-dev`. GMSH is usually installed from sources, and the build system expects to find it in `/opt/uliege/gmsh`. The GMSH from Debian should also be detected by the build system and work.

- The code uses CMake to handle the builds.

The whole procedure should be
```
git clone --recursive https://gitlab.onelab.info/mcicuttin/gmsh_gpu_dg.git
cd gmsh_gpu_dg
mkdir build
cd build
ccmake ..
make
```

If Eigen gives you compilation errors, install the last version from their site and configure the project with
```
ccmake .. -DEigen3_DIR=/your/eigen/install/path/eigen/cmake/
```

If you don't compile tests, you will get an executable called `maxwell_solver`. It takes a single parameter, the path of the Lua configuration script (see in `share` for some examples).

To visualize the results you need VisIt (https://wci.llnl.gov/simulation/computer-codes/visit).